Index: orxonox/trunk/src/track_manager.cc
===================================================================
--- orxonox/trunk/src/track_manager.cc	(revision 3365)
+++ orxonox/trunk/src/track_manager.cc	(revision 3365)
@@ -0,0 +1,544 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+
+#include "track_manager.h"
+#include <stdarg.h>
+
+
+using namespace std;
+
+/**
+   \brief initializes a TrackElement (sets the default values)
+*/
+TrackElement::TrackElement(void)
+{
+  this->isFresh = true;
+  this->isHotPoint = false;
+  this->isSavePoint = false;
+  this->isFork = false;
+  this->isJoined = false;
+  this->mainJoin = false;
+  this->cond; //!< todo think!!
+  this->ID = -1;
+  this->startingTime = 0; //!< \todo eventually set this to the max time of TrackManager.
+  this->duration = 1;
+  this->curveType = BEZIERCURVE;
+  this->nodeCount = 0;
+  this->childCount = 0;
+  this->name = NULL;
+  this->startPoint = Vector(0,0,0);
+  this->startTangentPoint = Vector(0,0,0);
+  this->curve = NULL;
+  this->children = NULL;
+}
+
+/** 
+    \brief destroys all alocated memory)
+    \todo eventually when deleting a TrackElement you would not like to delete all its preceding TrackElements
+*/
+TrackElement::~TrackElement(void)
+{
+  if (this->name)
+    delete []name;
+  if (this->curve)
+    delete this->curve;
+  if ((!this->isJoined &&this->childCount > 0) || (this->isJoined && this->mainJoin))
+    {
+      for (int i=0; i < this->childCount; i++)
+	delete this->children[i];
+      delete this->children;
+    }
+}
+
+/**
+   \brief Searches through all the TrackElements for trackID.
+   \param trackID The ID to search for.
+   \returns The TrackElement if Found, NULL otherwise.
+   
+   \todo make this more modular, to search for different things
+*/
+TrackElement* TrackElement::findByID(unsigned int trackID)
+{
+  // return if Found.
+  if (this->ID == trackID)
+    return this;
+  // search on.
+  if (this->childCount > 0)
+    for (int i=0; i < this->childCount; i++)
+      {
+	TrackElement* tmpElem;
+	if ((tmpElem = this->children[i]->findByID(trackID)))
+	  return tmpElem;
+      }
+  else return NULL;
+}
+
+
+
+
+
+/////////////////////////////////////
+///// TRACKMANAGER //////////////////
+/////////////////////////////////////
+/**
+   \brief standard constructor
+
+*/
+TrackManager::TrackManager(void)
+{
+  this->setClassName ("TrackManager");
+
+  PRINTF(3)("Initializing the TrackManager\n");
+  this->firstTrackElem = new TrackElement();
+  this->firstTrackElem->ID = 1;
+  this->currentTrackElem = firstTrackElem;
+  this->localTime = 0;
+  this->maxTime = 0;
+  this->trackElemCount = 1;
+}
+
+
+/**
+   \brief standard destructor
+
+*/
+TrackManager::~TrackManager(void)
+{
+  PRINTF(3)("Destruct TrackManager\n");
+
+  PRINTF(3)("Deleting all the TrackElements\n");
+  delete this->firstTrackElem;
+
+  // we do not have a TrackManager anymore
+  singletonRef = NULL;
+}
+
+TrackManager* TrackManager::singletonRef = NULL;
+
+/**
+   \returns The reference on the TrackManager.
+
+   If the TrackManager does not exist, it will be created.
+*/
+TrackManager* TrackManager::getInstance(void) 
+{
+  if (singletonRef)
+    return singletonRef;
+  else
+    return singletonRef = new TrackManager();
+}
+
+/**
+   \brief reserves Space for childCount children
+   \param childCount The Count of children to make space for.
+*/
+void TrackManager::initChildren(unsigned int childCount)
+{
+  this->currentTrackElem->childCount = childCount;
+  this->currentTrackElem->children = new TrackElement*[childCount];
+  for (int i=0; i<childCount; i++)
+    {
+      this->currentTrackElem->children[i] = new TrackElement();
+      this->currentTrackElem->children[i]->ID = ++trackElemCount;
+      this->currentTrackElem->children[i]->startingTime = this->currentTrackElem->startingTime+this->currentTrackElem->duration;
+      this->currentTrackElem->children[i]->startPoint = this->currentTrackElem->curve->getNode(this->currentTrackElem->curve->getNodeCount());
+      this->currentTrackElem->children[i]->startTangentPoint = (this->currentTrackElem->children[i]->startPoint *2) - this->currentTrackElem->curve->getNode(this->currentTrackElem->curve->getNodeCount()-1);
+    }
+}
+
+/**
+   \brief Searches for a given trackID.
+   \param trackID the trackID to search for.
+   \returns The TrackElement #trackID if found, NULL otherwise.
+*/
+TrackElement* TrackManager::findTrackElementByID(unsigned int trackID) const
+{
+  return firstTrackElem->findByID(trackID);
+}
+
+// INITIALIZE //
+
+/**
+   \brief Sets the trackID we are working on.
+   \param trackID the trackID we are working on
+*/
+void TrackManager::workOn(unsigned int trackID)
+{
+  TrackElement* tmpElem = findTrackElementByID(trackID);
+  if (tmpElem)
+    this->currentTrackElem = tmpElem;
+  else
+    printf("TrackElement not Found, leaving unchanged\n");
+  printf("now Working on %d\n", this->currentTrackElem->ID);
+
+}
+
+/**
+   \brief Sets the Type of the Curve
+   \brief curveType The Type to set
+*/
+void TrackManager::setCurveType(CurveType curveType)
+{
+  if (!this->currentTrackElem->isFresh)
+    {
+      PRINTF(2)("It is not possible to change the type of a Curve after you have have appended some points to it\n");
+      return;
+    }
+  this->currentTrackElem->curveType = curveType;
+  switch (curveType)
+    {
+    case BEZIERCURVE:
+      this->currentTrackElem->curve = new BezierCurve();
+      break;
+    case UPOINTCURVE:
+      this->currentTrackElem->curve = new UPointCurve();
+      break;
+    }
+}
+
+/**
+   \brief Sets the duration of the current path in seconds.
+   \param time The duration in seconds.
+*/
+
+void TrackManager::setDuration(float time)
+{
+  this->currentTrackElem->duration = time;
+}
+
+/**
+   \brief adds a point to the current TrackElement
+   \param newPoint The point to add.
+*/
+bool TrackManager::addPoint(Vector newPoint)
+{
+  return this->addPoint(newPoint, this->currentTrackElem);
+}
+
+/**
+   \brief adds a point to trackElem
+   \param newPoint The point to add.
+   \param trackElem The TrackElement to add the Point to
+*/
+bool TrackManager::addPoint(Vector newPoint, TrackElement* trackElem)
+{
+  if (trackElem->isFresh)
+    {
+      this->setCurveType(BEZIERCURVE);
+      trackElem->isFresh = false;
+      if(trackElem != this->firstTrackElem)
+	{
+	  this->addPoint(trackElem->startPoint);
+	  this->addPoint(trackElem->startTangentPoint);
+	}
+    }
+  trackElem->curve->addNode(newPoint);
+  trackElem->nodeCount++;
+}
+
+/**
+   \brief adds save/splitpoint.
+   \param newPoint The point to add.
+   \returns A Pointer to a newly appended Curve
+*/
+int TrackManager::addHotPoint(Vector newPoint)
+{
+  printf("setting up a HotPoint\n");
+  if (this->currentTrackElem->isFresh)
+    {
+      this->setCurveType(BEZIERCURVE);
+      this->currentTrackElem->isFresh = false;
+    }
+
+  // \todo HotPoint Handling.
+  this->currentTrackElem->curve->addNode(newPoint);
+  this->currentTrackElem->nodeCount++;
+  this->initChildren(1);
+  this->currentTrackElem = this->currentTrackElem->children[0];
+}
+
+/**
+   \brief Sets the last HotPoint into a savePoint.
+   \returns A Pointer to a newly appended Curve
+   
+   If no HotPoint was defined the last added Point will be rendered into a savePoint. \n
+   If the HotPoint was defined as a fork the Point will \b not be set into a savePoint.
+*/
+int TrackManager::setSavePoint(void)
+{
+  printf("setting up a SavePoint.\n");
+  if (this->currentTrackElem->isFork || this->currentTrackElem->isSavePoint)
+    return this->currentTrackElem->children[1]->ID;
+  this->currentTrackElem->isSavePoint = true;
+  this->currentTrackElem->isHotPoint = true;
+
+  this->initChildren(1);
+  this->currentTrackElem = this->currentTrackElem->children[0];
+}
+
+/**
+   \brief adds some interessting non-linear movments through the level.
+   \param count The Count of childrens the current HotPoint will have.
+
+   If no HotPoint was defined the last added Point will be rendered into a fork. \n
+   If the HotPoint was defined as a savePoint the Point will \b not be set into a fork.
+*/
+void TrackManager::fork(unsigned int count, ...)
+{
+  int* trackIDs = new int[count];
+  this->forkV(count, trackIDs);
+  va_list ID;
+  va_start (ID, count);
+  for(int i = 0; i < count; i++)
+    {
+      *va_arg (ID, int*) = trackIDs[i];
+    }
+  va_end(ID);  
+  delete []trackIDs;
+}
+
+/**
+   \brief adds some interessting non-linear movments through the level.
+   \param count The Count of childrens the current HotPoint will have.
+   \param trackIDs A Pointer to an Array of ints which will hold the trackID's (the user will have to reserve space for this).
+
+   \see void TrackManager::fork(int count, ...)
+
+   \todo initialisation is wrong!! also in setSavePoint.
+*/
+void TrackManager::forkV(unsigned int count, int* trackIDs)
+{
+  printf("Forking with %d children\n", count);
+  if (this->currentTrackElem->isSavePoint)
+    return;
+  this->currentTrackElem->isFork = true;
+  this->currentTrackElem->isHotPoint = true;
+  for(int i = 0; i < count; i++)
+    trackIDs[i]=this->trackElemCount+1+i;
+  this->initChildren(count);
+}
+
+/**
+   \brief decides under what condition a certain Path will be chosen.
+   \param groupID the ID on which to choose the preceding move
+   \param cond \todo think about this
+*/
+void TrackManager::condition(unsigned int groupID, PathCondition cond)
+{
+  
+}
+
+/**
+   \brief joins some tracks together again. 
+   \param count The count of Paths to join.
+
+   Join will set the localTime to the longest time a Path has to get to this Point. \n
+   Join will join all curves to the first curve, meaning that all the tangents will be matched.
+*/
+void TrackManager::join(unsigned int count, ...)
+{
+  int* trackIDs = new int [count];
+  va_list ID;
+  va_start (ID, count);
+  for(int i = 0; i < count; i++)
+    {
+      trackIDs[i] = va_arg (ID, int);
+    }
+  va_end(ID);
+  this->joinV(count, trackIDs);
+  delete []trackIDs;
+}
+
+/**
+   \brief joins some tracks together again. 
+   \param count The count of Paths to join.
+   \param trackIDs an Array with the trackID's to join
+
+   \see void TrackManager::join(int count, ...)
+*/
+void TrackManager::joinV(unsigned int count, int* trackIDs)
+{
+  printf("Joining %d tracks to Track %d\n", count, trackIDs[0]);
+
+  // chanching work-on to temporary value. going back at the end.
+  int tmpCurrentWorkingID = this->currentTrackElem->ID;
+  this->workOn(trackIDs[0]);
+
+  TrackElement* firstJoint = this->currentTrackElem;
+  Vector tmpEndPoint = firstJoint->curve->getNode(firstJoint->curve->getNodeCount());
+  Vector tmpTangentPoint = firstJoint->curve->getNode(firstJoint->curve->getNodeCount()-1); 
+  firstJoint->isJoined = true;
+  firstJoint->mainJoin = true;
+  if(!firstJoint->isHotPoint)
+    this->setSavePoint();
+
+  for (int i = 1; i < count; i++)
+    {
+      TrackElement* tmpJoinElem = this->findTrackElementByID(trackIDs[i]);
+      if (tmpJoinElem->childCount > 0)
+	printf("!!This Curve has children, and as such will not be joined!!\n You can try joining other childless TrackElements to this one!");
+      else
+	{
+	  this->addPoint(tmpTangentPoint, tmpJoinElem);
+	  this->addPoint(tmpEndPoint, tmpJoinElem);
+	  
+	  //Copying Joint-Info
+	  tmpJoinElem->children = firstJoint->children;
+	  tmpJoinElem->childCount = firstJoint->childCount;
+	  tmpJoinElem->isSavePoint = firstJoint->isSavePoint;
+	  tmpJoinElem->isFork = firstJoint->isFork;
+	  
+	  tmpJoinElem->isJoined = true;
+	}
+    }
+  // returning to the TrackElement we were working on.
+  this->workOn(tmpCurrentWorkingID);
+}
+
+// RUNTIME //
+
+/**
+   \brief calculates the Position for the localTime of the Track.
+   \returns the calculated Position
+*/
+Vector TrackManager::calcPos() const
+{
+  //  PRINTF(0)("TrackElement:%d, localTime: %f\n",this->currentTrackElem->ID, this->localTime);
+  return this->currentTrackElem->curve->calcPos((this->localTime-this->currentTrackElem->startingTime)/this->currentTrackElem->duration);
+}
+
+/**
+   \brief calculates the Rotation for the localTime of the Track.
+   \returns the calculated Rotation
+*/
+Vector TrackManager::calcDir() const
+{
+  return this->currentTrackElem->curve->calcDir((this->localTime-this->currentTrackElem->startingTime)/this->currentTrackElem->duration);
+}
+
+/**
+   \brief Advances the local-time of the Track around dt
+   \param dt The time about which to advance.
+
+   This function also checks, if the TrackElement has to be changed.
+*/
+void TrackManager::tick(float dt)
+{
+  if (this->localTime <= this->firstTrackElem->duration)
+    this->jumpTo(this->localTime);
+  this->localTime += dt;
+  if (this->localTime > this->currentTrackElem->startingTime + this->currentTrackElem->duration && this->currentTrackElem->childCount > 0)
+    this->currentTrackElem = this->currentTrackElem->children[0];
+}
+
+/**
+   \brief Jumps to a certain point on the Track.
+   \param time The time on the Track to jump to.
+
+   This should be used to Jump backwards on a Track, because moving forward means to change between the Path. (it then tries to choose the default.)
+   Max is trackLengthMax.
+*/
+void TrackManager::jumpTo(float time)
+{
+  if (time == 0)
+    this->currentTrackElem = this->firstTrackElem;
+  this->localTime = time;
+}
+
+/**
+   \brief a Function that decides which Path we should follow.
+   \param graphID The Path to choose.
+   
+*/
+void TrackManager::choosePath(int graphID)
+{
+
+}
+
+
+
+// DEBUG //
+
+/**
+   \brief Imports a model of the Graph into the OpenGL-environment.
+   \param dt The Iterator used in seconds for Painting the Graph.
+
+   This is for testing facility only. Do this if you want to see the Path inside the Level.
+   eventually this will all be packed into a gl-list.
+*/
+void TrackManager::drawGraph(float dt) const
+{
+
+  for (int i = 1; i <= trackElemCount; i++)
+    {
+      glBegin(GL_LINE_STRIP);
+      TrackElement* tmpElem = this->findTrackElementByID(i);
+      if (tmpElem->curve)
+	for(float f = 0.0; f < 1.0; f+=dt)
+	  {
+	    //      printf("%f, %f, %f\n",trackManager->calcPos().x, trackManager->calcPos().y, trackManager->calcPos().z);
+	    Vector tmpVector = tmpElem->curve->calcPos(f);
+	    glVertex3f(tmpVector.x, tmpVector.y, tmpVector.z);
+	  }
+  glEnd();
+    }
+}
+
+void TrackManager::debug(unsigned int level) const
+{
+  printf("::CLASS TRACKMANAGER::debug information::\n");
+  //  printf("Status is: %
+  printf(" Consists of %d elements\n", this->trackElemCount);
+  printf(" localTime is: %f\n", this->localTime);
+  if (level >= 2)
+    {
+      for (int i = 1; i <= trackElemCount; i++)
+	{
+	  TrackElement* tmpElem = this->findTrackElementByID(i);
+	  printf("  ::TrackElement:%i::", tmpElem->ID);
+	  if(tmpElem->name)
+	    printf("name:%s::", tmpElem->name);
+	  if(tmpElem->isFresh)
+	    printf("   has not jet eddited in any way\n");
+	  printf("\n   TimeTable: starting at = %f; ends at = %f; duration = %f\n", tmpElem->startingTime, tmpElem->startingTime+tmpElem->duration, tmpElem->duration);
+	  printf("   consists of %d Points\n", tmpElem->nodeCount);
+	  if (tmpElem->childCount == 0)
+	    printf("   has no child\n");	    
+	  else if (tmpElem->childCount == 1)
+	    printf("   has 1 child: ==%d==\n", tmpElem->children[0]->ID);
+	  else if (tmpElem->childCount > 1)
+	    {
+	      printf("   has %d children: ", tmpElem->childCount);
+	      for(int i = 0; i < tmpElem->childCount; i++)
+		printf("=%d= ", tmpElem->children[i]->ID);
+	      printf("\n");
+	    }
+
+	  if(tmpElem->isHotPoint)
+	    printf("   is a special Point:\n");
+	  if(tmpElem->isSavePoint)
+	    printf("    is a SavePoint\n");
+	  if(tmpElem->isFork)
+	    {
+	      printf("    is A Fork with with %d children.", tmpElem->childCount);
+	    }
+	  if(tmpElem->isJoined)
+	    printf("   is Joined at the End\n");
+	}
+    }
+}
Index: orxonox/trunk/src/track_manager.h
===================================================================
--- orxonox/trunk/src/track_manager.h	(revision 3365)
+++ orxonox/trunk/src/track_manager.h	(revision 3365)
@@ -0,0 +1,141 @@
+/*! 
+    \file track_manager.h
+    \brief manages all tracks defined in the world and the path the player takes
+
+    it is a container for all tracks and all track-nodes. it manages the movement of
+    the track helper-parent (that drives the player). it is responsable for calculating
+    smooth curves etc.
+*/
+
+
+#ifndef _TRACK_MANAGER_H
+#define _TRACK_MANAGER_H
+
+#include "stdincl.h"
+
+
+//! condition for choosing a certain Path. \todo implement a useful way.
+struct PathCondition
+{
+  
+};
+  
+
+//! A Graph-Element, that holds the curve-structure of a Level.
+/**
+   A TrackElement is used, to define the structure of the Track itself.
+   It is a graph and not a tree, because paths can fork and join again.
+*/
+class TrackElement
+{
+ public:
+  TrackElement(void);
+  ~TrackElement(void);
+
+  TrackElement* findByID(unsigned int trackID);
+
+  bool isFresh;              //!< If no Points where added until now
+  bool isHotPoint;           //!< If the first node is a specialPoint;
+  bool isSavePoint;          //!< If the first node is a savePoint
+  bool isFork;               //!< If the first node is a Fork
+  bool isJoined;             //!< If the End of the Curve is joined.
+  bool mainJoin;             //!< If the End of the Curve is joined, and this is the one Curve the others join to.
+  PathCondition cond;        //!< The Split Condition;
+  int ID;                    //!< The ID of this TrackElement
+  float startingTime;        //!< The time at which this Track begins.
+  float duration;            //!< The time used to cross this TrackElement (curve).
+  CurveType curveType;       //!< The CurveType this will have.
+  int nodeCount;             //!< The count of points this TrackElement has.
+  char* name;                //!< A name for the Trac.
+  Vector startPoint;         //!< A Vector that Points to the first point of the containing Curve. (for c1-steadiness)
+  Vector startTangentPoint;  //!< A Vector that points into the direction of the previous Curve. (for c1-steadiness)
+  Curve* curve;              //!< The Curve of this TrackElement
+  int childCount;            //!< The number of Children This TrackElement has.
+  TrackElement** children;   //!< A TrackElement can have a Tree of following TrackElements.
+};
+
+
+
+//! The TrackManager handles the flow of the Players through the game.
+/**
+   \todo write the methodes
+
+   <b>The TrackManager works as followed:</b> \n
+     \n
+   <b>1. Initialize it, by setting up the Graph. You can do this by using the following Commands.</b>
+    \li workOn(): changes the ID that will be altered through the changes.
+    \li setCurveType(): lets you set the CurveType of the Curve we are Working on. (default is BezierCurve, set this as early as possible, for this uses resources).
+    \li setDuration(): sets the length of the current path in seconds.
+    \li addPoint(): adds a point to the Curve.
+    \li addHotPoint(): adds save/splitpoint.\n
+    \li fork(): adds some interessting non-linear movments through the level (fork will force addHotPoint if not done then).
+    \li condition(): decides under what condition a certain Path will be chosen.
+    \li join(): joins some tracks together again. Join will set the localTime to the longest time a Path has to get to this Point)
+    \li setSavePoint(): Sets a HotPoint into a savePoint. A Savepoint can be used as a rollbackpoint if a Player gets shot.
+
+    HotPoints and Joins are at the beginning of a TrackElement. \n
+    SavePoints and Forks are at the end of a TrackElement \n
+    look out: <b>SAVEPOINTS CAN NOT BE FORKS</b> (but joins), because the condition is really hard to guess if you do not give some impuls. \n
+\n
+   <b> 2. Runtime knows the following: </b>
+    \li calcPos(): returns the current position on the track
+    \li calcDir(): returns the current Direction the track is flying on.
+    \li tick(): makes a Step on the Path. increases localTime by dt.
+    \li choosePath(): a Function that decides which Path we should follow.
+   
+   TrackManager can be handled as a StateMachine.
+   \n\n
+    Names: 
+    \li TrackManager: handles Tracks
+    \li Track:        The Track that the ship can follow
+    \li Path:         one way through the Level, that is dependent on conditionals.
+    \li Conditional:  A decition making device, that chooses betwen different TrackElements for the Path.
+    \li TrackElement: A Part of A whole Track
+*/
+class TrackManager : public BaseObject
+{
+ private:
+  TrackManager(void);
+
+  static TrackManager* singletonRef;  //!< There may only be one TrackManager existing.
+  TrackElement* firstTrackElem;       //!< The first TrackElement that exists.
+  TrackElement* currentTrackElem;     //!< The TrackElement we are working on.
+  float localTime;                    //!< The time that has been passed since the traveling the Track.
+  float maxTime;                      //!< The maximal time the track has.
+  int trackElemCount;                 //!< The count of TrackElements that exist.
+  
+  void initChildren(unsigned int childCount);
+
+  TrackElement* findTrackElementByID(unsigned int trackID) const;
+  
+ public:
+  ~TrackManager(void);
+  static TrackManager* getInstance(void);
+
+  // Methods to change the Path (initialisation)
+  void workOn(unsigned int trackID);
+  void setCurveType(CurveType curveType);
+  void setDuration(float time);
+  bool addPoint(Vector newPoint);
+  bool addPoint(Vector newPoint, TrackElement* trackElem);
+  int addHotPoint(Vector newPoint);
+  int setSavePoint(void);
+  void fork(unsigned int count, ...);
+  void forkV(unsigned int count, int* trackIDs);
+  void condition(unsigned int groupID, PathCondition cond); //!< \todo really do this!!
+  void join(unsigned int count, ...);
+  void joinV(unsigned int count, int* trackIDs);
+
+  // Methods to calculate the position on the Path (runtime)
+  Vector calcPos(void) const;
+  Vector calcDir(void) const;
+  void tick(float dt);
+  void jumpTo(float time);
+  void choosePath(int graphID);
+
+  // DEBUG //
+  void drawGraph(float dt) const;
+  void debug(unsigned int level) const;
+};
+
+#endif /* _TRACK_MANAGER_H */
Index: orxonox/trunk/src/vector.cc
===================================================================
--- orxonox/trunk/src/vector.cc	(revision 3364)
+++ orxonox/trunk/src/vector.cc	(revision 3365)
@@ -844,122 +844,2 @@
 }
 
-
-/**
-   \brief Creates a new BezierCurve
-*/
-BezierCurve::BezierCurve (void)
-{
-  nodeCount = 0;
-  firstNode = new PathNode;
-  currentNode = firstNode;
-
-  firstNode->position = Vector (.0, .0, .0);
-  firstNode->number = 0;
-  firstNode->next = 0; // not sure if this really points to NULL!!
-
-  return;
-}
-
-/**
-   \brief Deletes a BezierCurve.
-   It does this by freeing all the space taken over from the nodes
-*/
-BezierCurve::~BezierCurve (void)
-{
-  PathNode* tmpNode;
-  currentNode = firstNode;
-  while (tmpNode != 0)
-    {
-      tmpNode = currentNode;
-      currentNode = currentNode->next;
-      delete tmpNode;
-    }
-}
-
-/**
-   \brief adds a new Node to the bezier Curve
-   \param newNode a Vector to the position of the new node
-*/
-void BezierCurve::addNode(const Vector& newNode)
-{
-  PathNode* tmpNode;
-  if (nodeCount == 0 )
-    tmpNode = firstNode;
-  else
-    {
-      tmpNode = new PathNode;
-      currentNode = currentNode->next = tmpNode;
-    }
-  tmpNode->position = newNode;
-  tmpNode->next = 0; // not sure if this really points to NULL!!
-  tmpNode->number = (++nodeCount);
-  return;
-}
-
-/**
-   \brief calculates the Position on the curve
-   \param t The position on the Curve (0<=t<=1)
-   \return the Position on the Path
-*/
-Vector BezierCurve::calcPos(float t) 
-{
-  if (nodeCount <=4)
-    {
-      //      if (verbose >= 1)
-      //      printf ("Please define at least 4 nodes, until now you have only defined %i.\n", nodeCount);
-      curvePoint = Vector(0,0,0);
-    }
-  PathNode* tmpNode = firstNode;
-    
-  int k,kn,nn,nkn;
-  double blend,muk,munk;
-  Vector b = Vector(0.0,0.0,0.0);
-  
-  muk = 1;
-  munk = pow(1-t,(double)nodeCount);
-  
-  for (k=0; k<=nodeCount; k++) {
-    nn = nodeCount;
-    kn = k;
-    nkn = nodeCount - k;
-    blend = muk * munk;
-    muk *= t;
-    munk /= (1-t);
-    while (nn >= 1) {
-      blend *= nn;
-      nn--;
-      if (kn > 1) {
-	blend /= (double)kn;
-	kn--;
-      }
-      if (nkn > 1) {
-	blend /= (double)nkn;
-	nkn--;
-      }
-    }
-    b.x += tmpNode->position.x * blend;
-    b.y += tmpNode->position.y * blend;
-    b.z += tmpNode->position.z * blend;
-
-    tmpNode = tmpNode->next;
-  }
-  return b;
-}
-
-Vector BezierCurve::calcDirection (float t)
-{
-  double diff = .00000000001;
-  
-  Vector diffV = ((calcPos(t+diff) - calcPos(t))/diff);
-  diffV.normalize();
-  return diffV;
-}
-
-/**
-  \brief returns the Position of the point calculated on the Curve
-  \return a Vector to the calculated position
-*/
-Vector BezierCurve::getPos() const
-{
-  return curvePoint;
-}
Index: orxonox/trunk/src/vector.h
===================================================================
--- orxonox/trunk/src/vector.h	(revision 3364)
+++ orxonox/trunk/src/vector.h	(revision 3365)
@@ -149,39 +149,3 @@
 };
 
-
-
-//! Bezier Curve
-/**
-   Class to handle bezier curves in 3-dimesnsional space
-   
-   needed for  the Tracking system in OrxOnoX.
-*/
-class BezierCurve
-{
- private:
-  int nodeCount;
-  Vector curvePoint;
-  
-  struct PathNode
-  {
-    int number;
-    Vector position;
-    PathNode* next;
-  };
-
-  PathNode* firstNode; 
-  PathNode* currentNode; 
-
- public:
-  BezierCurve (void);
-  ~BezierCurve (void);
-  void addNode (const Vector& newNode);
-  Vector calcPos (float t);
-  Vector calcDirection (float t);
-  
-  Vector getPos () const;
-};
-
-
-
 #endif /* _VECTOR_H */
